KIO::TransferJob Class Reference

`#include <jobclasses.h>`

Inheritance diagram for KIO::TransferJob:

## Signals

void | data (KIO::Job *job, const QByteArray &data)
void | dataReq (KIO::Job *job, QByteArray &data)
void | redirection (KIO::Job *job, const KURL &url)
void | permanentRedirection (KIO::Job *job, const KURL &fromUrl, const KURL &toUrl)
void | mimetype (KIO::Job *job, const QString &type)
void | canResume (KIO::Job *job, KIO::filesize_t offset)
Signals inherited from KIO::Job
void | result (KIO::Job *job)
void | canceled (KIO::Job *job)
void | infoMessage (KIO::Job *job, const QString &msg)
void | warning (KIO::Job *job, const QString &msg)
void | connected (KIO::Job *job)
void | percent (KIO::Job *job, unsigned long percent)
void | totalSize (KIO::Job *job, KIO::filesize_t size)
void | processedSize (KIO::Job *job, KIO::filesize_t size)
void | speed (KIO::Job *job, unsigned long speed)

## Public Member Functions

| TransferJob (const KURL &url, int command, const QByteArray &packedArgs, const QByteArray &_staticData, bool showProgressInfo)
virtual void | start (Slave *slave)
virtual void | slotResult (KIO::Job *job)
void | suspend ()
void | resume ()
bool | isSuspended () const
bool | isErrorPage () const
void | setAsyncDataEnabled (bool enabled)
void | sendAsyncData (const QByteArray &data)
void | setReportDataSent (bool enabled)
bool | reportDataSent ()
Public Member Functions inherited from KIO::SimpleJob
| SimpleJob (const KURL &url, int command, const QByteArray &packedArgs, bool showProgressInfo)
const KURL & | url () const
virtual void | kill (bool quietly=true)
virtual void | putOnHold ()
void | slaveDone ()
Slave * | slave () const
int | command () const
Public Member Functions inherited from KIO::Job
int | error () const
int | progressId () const
const QString & | errorText () const
QString | errorString () const
QStringList | detailedErrorStrings (const KURL *reqUrl=0L, int method=-1) const
void | showErrorDialog (QWidget *parent=0L)
void | setAutoErrorHandlingEnabled (bool enable, QWidget *parentWidget=0)
bool | isAutoErrorHandlingEnabled () const
void | setAutoWarningHandlingEnabled (bool enable)
bool | isAutoWarningHandlingEnabled () const
void | setInteractive (bool enable)
bool | isInteractive () const
void | setWindow (QWidget *window)
QWidget * | window () const
void | updateUserTimestamp (unsigned long time)
void | setParentJob (Job *parentJob)
Job * | parentJob () const
void | setMetaData (const KIO::MetaData &metaData)
void | addMetaData (const QString &key, const QString &value)
void | addMetaData (const QMap< QString, QString > &values)
void | mergeMetaData (const QMap< QString, QString > &values)
MetaData | outgoingMetaData () const
MetaData | metaData () const
QString | queryMetaData (const QString &key)
KIO::filesize_t | getProcessedSize ()

## Protected Slots

virtual void | slotRedirection (const KURL &url)
virtual void | slotFinished ()
virtual void | slotData (const QByteArray &data)
virtual void | slotDataReq ()
virtual void | slotMimetype (const QString &mimetype)
virtual void | slotNeedSubURLData ()
virtual void | slotSubURLData (KIO::Job *, const QByteArray &)
virtual void | slotMetaData (const KIO::MetaData &_metaData)
void | slotErrorPage ()
void | slotCanResume (KIO::filesize_t offset)
void | slotPostRedirection ()
Protected Slots inherited from KIO::SimpleJob
virtual void | slotFinished ()
void | slotWarning (const QString &)
void | slotInfoMessage (const QString &s)
void | slotConnected ()
void | slotProcessedSize (KIO::filesize_t data_size)
void | slotSpeed (unsigned long speed)
virtual void | slotMetaData (const KIO::MetaData &_metaData)
void | slotNeedProgressId ()
Protected Slots inherited from KIO::Job
void | slotSpeed (KIO::Job *job, unsigned long speed)
void | slotInfoMessage (KIO::Job *job, const QString &msg)
void | slotSpeedTimeout ()

## Protected Member Functions

virtual void | virtual_hook (int id, void *data)
Protected Member Functions inherited from KIO::SimpleJob
void | storeSSLSessionFromJob (const KURL &m_redirectionURL)
Protected Member Functions inherited from KIO::Job
| Job (bool showProgressInfo)
virtual void | addSubjob (Job *job, bool inheritMetaData=true)
virtual void | removeSubjob (Job *job)
void | removeSubjob (Job *job, bool mergeMetaData, bool emitResultIfLast)
void | emitPercent (KIO::filesize_t processedSize, KIO::filesize_t totalSize)
void | emitSpeed (unsigned long speed)
void | emitResult ()
void | setProcessedSize (KIO::filesize_t size)
unsigned long | userTimestamp () const
int & | extraFlags ()

## Protected Attributes

bool | m_suspended
bool | m_errorPage
QByteArray | staticData
KURL | m_redirectionURL
KURL::List | m_redirectionList
QString | m_mimetype
TransferJob * | m_subJob
Protected Attributes inherited from KIO::SimpleJob
Slave * | m_slave
QByteArray | m_packedArgs
KURL | m_url
KURL | m_subUrl
int | m_command
KIO::filesize_t | m_totalSize
Protected Attributes inherited from KIO::Job
QPtrList< Job > | subjobs
int | m_error
QString | m_errorText
unsigned long | m_percent
int | m_progressId
QTimer * | m_speedTimer
QGuardedPtr< QWidget > | m_window
MetaData | m_outgoingMetaData
MetaData | m_incomingMetaData

## Additional Inherited Members

Public Slots inherited from KIO::SimpleJob
void | slotTotalSize (KIO::filesize_t data_size)
virtual void | slotError (int, const QString &)
Static Public Member Functions inherited from KIO::SimpleJob
static void | removeOnHold ()
Protected Types inherited from KIO::Job
enum | { EF_TransferJobAsync = (1 << 0), EF_TransferJobNeedData = (1 << 1), EF_TransferJobDataSent = (1 << 2), EF_ListJobUnrestricted = (1 << 3) }

## Detailed Description

The transfer job pumps data into and/or out of a Slave.

Data is sent to the slave on request of the slave ( dataReq). If data coming from the slave can not be handled, the reading of data from the slave should be suspended.

Definition at line 875 of file jobclasses.h.

## Constructor & Destructor Documentation

TransferJob::TransferJob | ( | const KURL & | url,
|  | int | command,
|  | const QByteArray & | packedArgs,
|  | const QByteArray & | _staticData,
|  | bool | showProgressInfo
| ) |  |

Do not create a TransferJob.

Use KIO::get() or KIO::put() instead.

Parameters

  url | the url to get or put
  command | the command to issue
  packedArgs | the arguments
  _staticData | additional data to transmit (e.g. in a HTTP Post)
  showProgressInfo | true to show progress information to the user

Definition at line 916 of file job.cpp.

## Member Function Documentation

void KIO::TransferJob::data | ( | KIO::Job * | job,
|  | const QByteArray & | data
| ) |  |

signal

Data from the slave has arrived.

Parameters

  job | the job that emitted this signal
  data | data received from the slave.

End of data (EOD) has been reached if data.size() == 0, however, you should not be certain of data.size() == 0 ever happening (e.g. in case of an error), so you should rely on result() instead.

void KIO::TransferJob::dataReq | ( | KIO::Job * | job,
|  | QByteArray & | data
| ) |  |

signal

Request for data.

Please note, that you shouldn't put too large chunks of data in it as this requires copies within the frame work, so you should rather split the data you want to pass here in reasonable chunks (about 1MB maximum)

Parameters

  job | the job that emitted this signal
  data | buffer to fill with data to send to the slave. An empty buffer indicates end of data. (EOD)

bool KIO::TransferJob::isErrorPage | ( |  | ) | const

inline

Checks whether we got an error page.

This currently only happens with HTTP urls. Call this from your slot connected to result().

    @return true if we got an (HTML) error page from the server
    instead of what we asked for.

Definition at line 931 of file jobclasses.h.

bool KIO::TransferJob::isSuspended | ( |  | ) | const

inline

Flow control.

Returns
  true if the job is suspended

Definition at line 921 of file jobclasses.h.

void KIO::TransferJob::mimetype | ( | KIO::Job * | job,
|  | const QString & | type
| ) |  |

signal

Mimetype determined.

Parameters

  job | the job that emitted this signal
  type | the mime type

void KIO::TransferJob::permanentRedirection | ( | KIO::Job * | job,
|  | const KURL & | fromUrl,
|  | const KURL & | toUrl
| ) |  |

signal

Signals a permanent redirection.

The redirection itself is handled internally.

Parameters

  job | the job that emitted this signal
  fromUrl | the original URL
  toUrl | the new URL

Since
  3.1

void KIO::TransferJob::redirection | ( | KIO::Job * | job,
|  | const KURL & | url
| ) |  |

signal

Signals a redirection.

Use to update the URL shown to the user. The redirection itself is handled internally.

Parameters

  job | the job that emitted this signal
  url | the new URL

bool TransferJob::reportDataSent | ( |  | ) |

Returns whether the job reports the amount of data that has been sent (true), or whether the job reports the amount of data that has been received (false)

Since
  3.2

Definition at line 1064 of file job.cpp.

void TransferJob::resume | ( |  | ) |

Flow control.

Resume data processing from the slave.

Definition at line 1122 of file job.cpp.

void TransferJob::sendAsyncData | ( | const QByteArray & | data | ) |

Provide data to the job when async data is enabled.

Should be called exactly once after receiving a dataReq signal Sending an empty block indicates end of data.

Since
  3.2

Definition at line 1036 of file job.cpp.

void TransferJob::setAsyncDataEnabled | ( | bool | enabled | ) |

Enable the async data mode.

When async data is enabled, data should be provided to the job by calling sendAsyncData() instead of returning data in the dataReq() signal.

Since
  3.2

Definition at line 1028 of file job.cpp.

void TransferJob::setReportDataSent | ( | bool | enabled | ) |

When enabled, the job reports the amount of data that has been sent, instead of the amount of data that that has been received.

See also
  slotProcessedSize
  slotSpeed

Since
  3.2

Definition at line 1056 of file job.cpp.

void TransferJob::slotResult | ( | KIO::Job * | job | ) |

virtual

Called when m_subJob finishes.

Parameters

  job | the job that finished

Reimplemented from KIO::Job.

Definition at line 1198 of file job.cpp.

void TransferJob::suspend | ( |  | ) |

Flow control.

Suspend data processing from the slave.

Definition at line 1115 of file job.cpp.

The documentation for this class was generated from the following files:

- jobclasses.h
- job.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys